function [err,A,F,EU,U,b]=appro2DNCTT(T,dt,n,min,max,ef1,ef2)

x=linspace(min,max,n);
y = x;
r = 2.5;
I=eye(n-2);
h = 1/(n-1);
b=zeros(n-2,n-2);
i=1;
b(i,i)=2;
b(i,i+1)=-1;
for i=2:n-3
    b(i,i-1)=-1;
    b(i,i)=2;
    b(i,i+1)=-1;
end
i=n-2;
b(i,i)=2;
b(i,i-1)=-1;
B=(kron(I,b)+kron(b,I));


F1=zeros((n-2)^2,1);
for i=2:n-1
    for j=2:n-1
        F1((i-2)*(n-2)+(j-1))=ef1(x(i) + h/2,y(j) + h/2);
    end
end

F2=zeros((n-2)^2,1);
for i=2:n-1
    for j=2:n-1
        F2((i-2)*(n-2)+(j-1))=r*ef1(x(i),y(j)) + ef2(x(i),y(j));
    end
end
%F = -((n-1)^-2)*F;
F = [F1;F2];


EU1 = zeros((n-2)^2,1);
EU2 = zeros((n-2)^2,1);
for i=2:n-1
    for j=2:n-1
        EU1((i-2)*(n-2)+(j-1))=sin(2*x(i))*sin(2*y(j));
    end
end

%EU1 = 0*EU1;
eeU1 = 0*EU1;
for i=2:n-1
    for j=2:n-1
        EU2((i-2)*(n-2)+(j-1))=sin(2*(x(i) + h/2))*sin(2*(y(j) + h/2));
    end
end

eeU2 = (3/2)*EU2;

%EU2 = (3/2)*EU2;

EU = [eeU1;eeU2];
BI = eye((n-2)^2);
A = [BI, (dt/(h^2))*B;(-dt/(h^2))*B + r*BI,BI];

U=A\F;
e=abs(U-EU);
%error = max(e);
err = e;
%err = max(error);

k = T/dt;

for j = 1 : k
    U1 = A\U;
    eU1 = (exp(-4*j*dt) - exp(-16*j*dt))*EU1;
    eU2 = (2*exp(-16*j*dt) - (0.5)*exp(-4*j*dt))*EU2;
    EEU = [eU1;eU2];
    e=abs(U1-EEU);
    err = e;
end



end